
# ------------------------------------------------------------
# Set of definitions and macros for CMAKE 
# specific to the managing of the documentation (Tex output)
# ------------------------------------------------------------
# Author: Loïc Besnard 
# Email: Loic.Besnard@irisa.fr
# ------------------------------------------------------------

SET(LATEX_NAME_FILE_DOC_REGISTER implementationRegister.tex)

MACRO(TEX_NEWCOMMAND FILE CMDNAME VALUE)
  STRING(REPLACE 2 To  CMDNAME1 ${CMDNAME})
  FILE(APPEND ${FILE} "\\newcommand{\\${CMDNAME1}} {\\mbox{${VALUE}}}\n")
ENDMACRO(TEX_NEWCOMMAND FILE CMDNAME VALUE)


MACRO(TEX_NEWCOMMAND_1 FILE CMDNAME VALUE)
  STRING(REPLACE 2 To  CMDNAME1 ${CMDNAME})
  FILE(APPEND ${FILE} "\\newcommand{\\${CMDNAME1}} {${VALUE}}\n")
ENDMACRO(TEX_NEWCOMMAND_1 FILE CMDNAME VALUE)


MACRO(TEX_NEWCOMMAND_TEXT FILE )
  FILE(APPEND ${FILE} "\\newcommand{\\text} [1] {\\mbox{#1\ details}}\n")
ENDMACRO(TEX_NEWCOMMAND_TEXT FILE)

MACRO(TEX_NEWCOMMAND_INDEX PACKAGE ADDRINDEX TEXT)
  STRING(REPLACE 2 To  PACKAGE1 "${PACKAGE}")
  FILE(APPEND ${DOCREGISTER_TMP_FILE} "\\newcommand{\\${PACKAGE1}HTMLindex} {\\mbox{\\href{${ADDRINDEX}/index.html} {\\tt \\text{${TEXT}}}}}\n")
ENDMACRO(TEX_NEWCOMMAND_INDEX CMDNAME ADDRINDEX  TEXT)

# -----------------------------------------------------------------------------------
# It initializes the docRegister.tex file, for Signal Toolbox
# -----------------------------------------------------------------------------------
MACRO(TEX_INIT_SIGNALTOOLBOX_DOCREGISTER)
  SET(DOCREGISTER_TMP_FILE  ${pK_ROOT}/doc/lib/__tmp)
  FILE(REMOVE ${DOCREGISTER_TMP_FILE})
ENDMACRO(TEX_INIT_SIGNALTOOLBOX_DOCREGISTER)

MACRO(TEX_GEN_DOCREGISTER)
  SET(DOCREGISTER_FILE ${pK_ROOT}/doc/lib/${LATEX_NAME_FILE_DOC_REGISTER})
  FILE(REMOVE ${DOCREGISTER_FILE})
  GEN_COMMENT_AUTOGEN1(${DOCREGISTER_FILE} "%" " ")
  MK_SYSTEM_PATH("$ENV{pK_ROOT}" XX)
  TEX_NEWCOMMAND_TEXT(${DOCREGISTER_FILE})
  TEX_NEWCOMMAND(${DOCREGISTER_FILE} PolychronyToolset "${XX}")
  TEX_NEWCOMMAND_1(${DOCREGISTER_FILE} PolychronyToolsetNode "${XX}")
  TEX_NEWCOMMAND(${DOCREGISTER_FILE} pKVersion ${SIGNAL_TOOLBOX_VERSION})
  TEX_NEWCOMMAND(${DOCREGISTER_FILE} pKGUIVersion ${SIGNAL_GUI_VERSION})
  #  catenating files.
  IF(EXISTS ${DOCREGISTER_TMP_FILE})
    FILE(READ ${DOCREGISTER_TMP_FILE} YYY)
    FILE(APPEND ${DOCREGISTER_FILE} ${YYY})
    FILE(REMOVE ${DOCREGISTER_TMP_FILE})
  ENDIF(EXISTS ${DOCREGISTER_TMP_FILE})

  ENDMACRO(TEX_GEN_DOCREGISTER )
