process VTMOUSE_P1 =
     { integer N, M, NUL_CODE, LIN_CODE, TICK_NUMBER, FRONT_NUMBER, TICK_HEIGHT, DELTA, TICK_WIDTH; }
     ( ? event H;
       ! event INTER;
     )
   (| (| MOUSE{M}
       | (| HE := H
          | CONTEXT{N,NUL_CODE,LIN_CODE}
          |) where event HE; end
       | (| HE := HE_1
          | SCREEN{TICK_NUMBER,FRONT_NUMBER,TICK_HEIGHT,DELTA,TICK_WIDTH}
          |) where event HE; end
       | (| BACK{}
          | HE_1 := HE
          |) where event HE; end
       | INTER := START when RELAX
       |)/ C5, C4, C3, C2, S1, C1, HE_1, CLICK, TICK, H_0, DOUBLE, SINGLE, RELAX, START |)
   where 
   use CONTEXT_LIB, SCREEN_LIB; 
   process MOUSE =
        { integer M; }
        ( ? event TICK;
            event CLICK;
          ! event START;
            event RELAX;
            event SINGLE;
            event DOUBLE;
        )
      (| (| START_RELAX := DEF_INTERVAL{false}(START,RELAX)
          | START_RELAX ^= CLICK default TICK
          |)
       | (| START := OUT_INTERVAL(CLICK,START_RELAX)
          | RELAX := DYN_EVERY_AFTER{0,M,M}(0 when START,M when START,IN_INTERVAL(TICK,START_RELAX),START)
          |)
       | (| DOUBLE_CLICK := ((not (when START)) default IN_INTERVAL(CLICK,START_RELAX)) cell RELAX
          | DOUBLE := RELAX when DOUBLE_CLICK
          | SINGLE := RELAX when (not DOUBLE_CLICK)
          |)
       |)
      where 
      boolean START_RELAX, DOUBLE_CLICK;
      process IN_INTERVAL =
           ( ? X;
               boolean INTERVAL;
             ! SX;
           )
         (| SX := X when INTERVAL |)
      ; 
      process DEF_INTERVAL =
           { boolean INIT_INTERVAL; }
           ( ? event H1;
               event H2;
             ! boolean INTERVAL;
           )
         (| WBI := ((not H2) when BTI) default H1 default BTI
          | BTI := WBI$1
          | INTERVAL := BTI
          |)
         where 
         boolean WBI, BTI init INIT_INTERVAL;
         end
      ; 
      process OUT_INTERVAL =
           ( ? X;
               boolean INTERVAL;
             ! SX;
           )
         (| SX := X when (not INTERVAL) |)
      ; 
      process DYN_EVERY_AFTER =
           { integer PHY_0, PI_0, V_0; }
           ( ? integer PHY;
               integer PERIOD;
               event HE;
               event HRESET;
             ! event HS;
           )
         (| H := HE default HRESET
          | MAX1 := ((0 when (PERIOD<=1)) default (PERIOD-1)) cell H
          | MAX := MAX1 when H
          | CPHY1 := ((0 when (PHY<0)) default PHY) cell H
          | CPHY := CPHY1 when H
          | ZV := V$1
          | V := (0 when HRESET) default (0 when (ZV>=MAX)) default (ZV+1)
          | HS := HE when (V=CPHY)
          |)
         where 
         integer MAX1 init PI_0-1, MAX, CPHY1 init PHY_0, CPHY, ZV init V_0, V;
         event H;
         end
      ; 
      end
   ; 
   process SCREEN =
        { integer TICK_NUMBER, FRONT_NUMBER, TICK_HEIGHT, DELTA, TICK_WIDTH; }
        ( ? event H_0;
            event HE;
            boolean C1;
            boolean S1;
            boolean C2;
            boolean C3;
            boolean C4;
            boolean C5;
        )
      (| (| X := WSET{TICK_NUMBER,FRONT_NUMBER,3*TICK_HEIGHT,DELTA+DELTA+TICK_WIDTH}(SCREEN,HE)
          | WBOOLININTER{-TICK_HEIGHT,2*TICK_HEIGHT,DELTA,TICK_WIDTH}(SCREEN,C1,S1,X)
          | (| WBOOL{-TICK_HEIGHT,-((TICK_HEIGHT*3)/4),DELTA,TICK_WIDTH}(SCREEN,C2,X)
             | WBOOL{-TICK_HEIGHT,-TICK_HEIGHT,DELTA,TICK_WIDTH}(SCREEN,C3,X)
             |)
          | (| WBOOL{TICK_HEIGHT,-TICK_HEIGHT,DELTA,TICK_WIDTH}(SCREEN,C4,X)
             | WBOOL{2*TICK_HEIGHT,-TICK_HEIGHT,DELTA,TICK_WIDTH}(SCREEN,C5,X)
             |)
          | INITSCREEN{}
          |)/ SCREEN, X |)
      where 
      integer X, SCREEN;
      end
   ; 
   process BACK =
        ( ? event TICK;
            event START;
            event RELAX;
            event SINGLE;
            event DOUBLE;
            event CLICK;
          ! event HE;
            boolean C1;
            boolean S1;
            boolean C2;
            boolean C3;
            boolean C4;
            boolean C5;
        )
      (| HE := CLICK default TICK
       | C1 := (not RELAX) default START
       | NS := C1 default S1
       | S1 := NS$1
       | HE ^= S1
       | C2 := not TICK
       | C3 := CLICK
       | C4 := not SINGLE
       | C5 := not DOUBLE
       |)
      where 
      boolean NS;
      end
   ; 
   process CONTEXT =
        { integer N, NUL_CODE, LIN_CODE; }
        ( ? event HE;
          ! event H_0;
            event TICK;
            event CLICK;
        )
      (| (| S_PACE_MAKER{NUL_CODE,LIN_CODE}
          | (| H := HES
             | SCAN{N}
             |) where event H; end
          |)/ HES |)
      where 
      process SCAN =
           { integer N; }
           ( ? event H;
             ! event TICK;
               event CLICK;
           )
         (| CLICK := GETSIG{}(H,RCLICK())
          | TICK := DYN_EVERY{0,N,N}(0 when H,N when H,H)
          |)
         where 
         process GETSIG =
              ( ? event H;
                  boolean C_ON;
                ! event ON;
              )
            (| H ^= C_ON
             | ON := when C_ON
             |)
         ; 
         process RCLICK =
              ( ! boolean CLICK;
              )
         
         ; 
         end
      ; 
      event HES;
      end
   ; 
   process DYN_EVERY =
        { integer PHY_0, PI_0, V_0; }
        ( ? integer PHY;
            integer PERIOD;
            event HE;
          ! event HS;
        )
      (| MAX1 := ((0 when (PERIOD<=1)) default (PERIOD-1)) cell HE
       | MAX := MAX1 when HE
       | CPHY1 := ((0 when (PHY<0)) default PHY) cell HE
       | CPHY := CPHY1 when HE
       | ZV := V$1
       | V := (0 when (ZV>=MAX)) default (ZV+1)
       | HS := when (V=CPHY)
       |)
      where 
      integer MAX1 init PI_0-1, MAX, CPHY1 init PHY_0, CPHY, ZV init V_0, V;
      end
   ; 
   event START, RELAX, SINGLE, DOUBLE, H_0, TICK, CLICK, HE_1, HE;
   boolean C1, S1 init false, C2, C3, C4, C5;
   end
; 
