process CONTROLLER =
     { boolean TABLE_FREE;
       real CRANE_HEIGHT_MIN, CRANE_HEIGHT_MAX, TABLE_ANGLE_MIN, TABLE_ANGLE_MAX;
       real ANGLE_MIN_ARM1_SAFE, ANGLE_MAX_ARM1_SAFE, ANGLE_MIN_ARM2_SAFE, ANGLE_MAX_ARM2_SAFE;
       boolean INI_MIDDLE; }
     ( ? [14]real SENSORS;
       ! event REACT_CLOCK;
     )
   (| (| (| CTRL_TRANSPORT{TABLE_FREE,CRANE_HEIGHT_MIN,CRANE_HEIGHT_MAX,TABLE_ANGLE_MIN,TABLE_ANGLE_MAX}
          | COMMANDS_CLOCK_1 := COMMANDS_CLOCK
          |) where COMMANDS_CLOCK; end
       | (| BELT_READY_LOADED := DEPOSIT_BELT_READY_LOADED
          | CTRL_ROBOT_PRESS{ANGLE_MIN_ARM1_SAFE,ANGLE_MAX_ARM1_SAFE,ANGLE_MIN_ARM2_SAFE,ANGLE_MAX_ARM2_SAFE,INI_MIDDLE}
          | COMMANDS_CLOCK_2 := COMMANDS_CLOCK
          |) where event BELT_READY_LOADED;
                   COMMANDS_CLOCK; end
       | (| I2 := COMMANDS_CLOCK_2
          | I1 := COMMANDS_CLOCK_1
          | O := I1 default I2 default I3
          | REACT_CLOCK := O
          |) where event O;
                   I1, I2; end
       | I3 := ^SENSORS
       |)/ I3, COMMANDS_CLOCK_2, TABLE_EMPTY, COMMANDS_CLOCK_1, DEPOSIT_BELT_READY_LOADED, TABLE_READY_TO_UNLOAD |)
   where 
   process CTRL_TRANSPORT =
        { boolean TABLE_FREE;
          real CRANE_HEIGHT_MIN, CRANE_HEIGHT_MAX, TABLE_ANGLE_MIN, TABLE_ANGLE_MAX; }
        ( ? [14]real SENSORS;
            TABLE_EMPTY;
          ! COMMANDS_CLOCK;
            TABLE_READY_TO_UNLOAD;
            event DEPOSIT_BELT_READY_LOADED;
        )
      (| (| SENSORS_TRANSPORT{}
          | (| H := SENSORS_CLOCK
             | D_14_SENSOR := DEP_PHOTOCELL
             | F_13_SENSOR := FEED_PHOTOCELL
             | C_12_CURRENT_HEIGHT := CRANE_HEIGHT
             | F_11_ABOVE := CRANE_ABOVE_FEED
             | D_10_ABOVE := CRANE_ABOVE_DEP
             | T_9_POS := TABLE_ANGLE
             | T_8_TOP := TABLE_HIGH
             | T_7_BOTTOM := TABLE_LOW
             | T_EMPTY := TABLE_EMPTY
             | TRANSPORT{TABLE_FREE,CRANE_HEIGHT_MIN,CRANE_HEIGHT_MAX,TABLE_ANGLE_MIN,TABLE_ANGLE_MAX}
             | TABLE_READY_TO_UNLOAD := T_READY_UNL
             | DEPOSIT_BELT_READY_LOADED := D_START
             |) where T_EMPTY, T_READY_UNL, T_7_BOTTOM, T_8_TOP, T_9_POS, D_10_ABOVE, F_11_ABOVE, C_12_CURRENT_HEIGHT, F_13_SENSOR, D_14_SENSOR, H;
                      event D_START; end
          | (| TABLE_STOP_H := T_H_STOP
             | TABLE_RIGHT := GO_TABLE_ROBOT
             | TABLE_LEFT := GO_TABLE_FEED
             | TABLE_STOP_V := T_V_STOP
             | TABLE_DOWNWARD := T_START_DOWN
             | TABLE_UPWARD := T_V_START_UP
             | CRANE_MAG_OFF := C_DROP
             | CRANE_MAG_ON := C_PICK_UP
             | CRANE_STOP_H := C_H_STOP
             | CRANE_TO_BELT1 := GO_CRANE_FEED
             | CRANE_TO_BELT2 := GO_CRANE_DEP
             | CRANE_STOP_V := C_V_STOP
             | CRANE_LIFT := C_V_START_UP
             | CRANE_LOWER := C_V_START_DOWN
             | BELT1_STOP := F_STOP
             | BELT1_START := F_START
             | BELT2_STOP := D_STOP
             | BELT2_START := DEPOSIT_BELT_READY_LOADED
             | SEND_COMMANDS{}
             |) where event BELT2_START;
                      BELT2_STOP, BELT1_START, BELT1_STOP, CRANE_LOWER, CRANE_LIFT, CRANE_STOP_V, CRANE_TO_BELT2, CRANE_TO_BELT1, CRANE_STOP_H, CRANE_MAG_ON, CRANE_MAG_OFF, TABLE_UPWARD, TABLE_DOWNWARD, TABLE_STOP_V, TABLE_LEFT, TABLE_RIGHT, TABLE_STOP_H; 
            end
          |)/ T_H_STOP, GO_TABLE_ROBOT, GO_TABLE_FEED, T_V_STOP, T_START_DOWN, T_V_START_UP, C_DROP, C_PICK_UP, C_H_STOP, GO_CRANE_FEED, GO_CRANE_DEP, C_V_STOP, C_V_START_UP, C_V_START_DOWN, F_STOP, F_START, D_STOP, SENSORS_CLOCK, DEP_PHOTOCELL, 
              FEED_PHOTOCELL, CRANE_HEIGHT, CRANE_ABOVE_FEED, CRANE_ABOVE_DEP, TABLE_ANGLE, TABLE_HIGH, TABLE_LOW |)
      where 
      boolean PRESS_AT_LOW, ZPRESS_AT_LOW init false, PRESS_AT_HIGH, ZPRESS_AT_HIGH init false;
      process FRONT =
           { boolean V0; }
           ( ? BOOLEEN;
             ! FRONT;
           )
         (| (| FRONT := (when (BOOLEEN and (not ZBOOLEEN))) default (not (when ((not BOOLEEN) and ZBOOLEEN)))
             | ZBOOLEEN := BOOLEEN$1
             |)/ ZBOOLEEN |)
         where 
         boolean ZBOOLEEN init V0;
         end
      ; 
      process TRANSPORT =
           { boolean TABLE_FREE;
             real MIN_HEIGHT, MAX_HEIGHT, MIN_POS, MAX_POS; }
           ( ? event T_8_TOP;
               event T_7_BOTTOM;
               real T_9_POS;
               event T_EMPTY;
               event H;
               boolean F_13_SENSOR;
               event F_11_ABOVE;
               real C_12_CURRENT_HEIGHT;
               event D_10_ABOVE;
               boolean D_14_SENSOR;
             ! event GO_TABLE_FEED;
               event T_START_DOWN;
               event GO_TABLE_ROBOT;
               event T_READY_UNL;
               event T_H_STOP;
               event T_V_STOP;
               event T_V_START_UP;
               event F_STOP;
               event F_START;
               event GO_CRANE_DEP;
               event C_V_START_DOWN;
               event C_DROP;
               event C_PICK_UP;
               event C_H_STOP;
               event C_V_STOP;
               event C_V_START_UP;
               event GO_CRANE_FEED;
               event D_STOP;
               event D_START;
           )
         (| (| (| READY := READY_LOAD
                | SENSOR := F_13_SENSOR
                | FEED_BELT{TABLE_FREE}
                | F_STOP := STOP
                | F_START := START
                | ACCEPT_1 := ACCEPT
                |) where boolean SENSOR;
                         event STOP, START, READY;
                         ACCEPT; end
             | (| READY := GO_CRANE_FEED
                | SENSOR := D_14_SENSOR
                | DEPOSIT_BELT{}
                | D_STOP := STOP
                | D_START := START
                | ACCEPT_2 := ACCEPT
                |) where boolean SENSOR;
                         event READY, STOP, START;
                         ACCEPT; end
             | (| PICK_ACCEPT := ACCEPT_2
                | DEPOSIT_ACCEPT := ACCEPT_1
                | D_ABOVE := D_10_ABOVE
                | CURRENT_HEIGHT := C_12_CURRENT_HEIGHT
                | F_ABOVE := F_11_ABOVE
                | CRANE{MIN_HEIGHT,MAX_HEIGHT,MIN_HEIGHT}
                | GO_CRANE_DEP := GO_TO_DEP
                | C_V_START_DOWN := V_START_DOWN
                | C_DROP := DROP
                | C_PICK_UP := PICK_UP
                | C_H_STOP := H_STOP
                | C_V_STOP := V_STOP
                | C_V_START_UP := V_START_UP
                | GO_CRANE_FEED := GO_TO_FEED
                |) where event F_ABOVE, D_ABOVE, GO_TO_DEP, V_START_DOWN, DROP, PICK_UP, H_STOP, V_STOP, V_START_UP, GO_TO_FEED;
                         real CURRENT_HEIGHT;
                         DEPOSIT_ACCEPT, PICK_ACCEPT; end
             | (| SENSOR := F_13_SENSOR
                | TABLE_EMPTY := T_EMPTY
                | CURRENT_POS := T_9_POS
                | BOTTOM := T_7_BOTTOM
                | TOP := T_8_TOP
                | (| TABLE_LOADED := when (not SENSOR)
                   | TABLE{MIN_POS,MAX_POS,MIN_POS}
                   |)
                | GO_TABLE_FEED := GO_TO_FEED
                | T_START_DOWN := V_START_DOWN
                | GO_TABLE_ROBOT := GO_TO_ROBOT
                | T_READY_UNL := READY_UNLOAD
                | T_H_STOP := H_STOP
                | T_V_STOP := V_STOP
                | T_V_START_UP := V_START_UP
                |) where event TOP, BOTTOM, TABLE_EMPTY, GO_TO_FEED, V_START_DOWN, GO_TO_ROBOT, READY_UNLOAD, H_STOP, V_STOP, V_START_UP;
                         real CURRENT_POS;
                         boolean SENSOR; end/ TABLE_LOADED
             |)/ READY_LOAD, ACCEPT_2, ACCEPT_1 |)
         where 
         process CRANE =
              { real MIN_HEIGHT, MAX_HEIGHT, INI_POS; }
              ( ? event H;
                  real CURRENT_HEIGHT;
                  event F_ABOVE;
                  event DEPOSIT_ACCEPT;
                  event D_ABOVE;
                  event PICK_ACCEPT;
                ! event H_STOP;
                  event V_STOP;
                  event GO_TO_FEED;
                  event V_START_UP;
                  event DROP;
                  event PICK_UP;
                  event GO_TO_DEP;
                  event V_START_DOWN;
              )
            (| (| (| OK_GO := PICK_UP
                   | ABOVE := F_ABOVE
                   | D_TO_F_MOVING{MIN_HEIGHT,INI_POS}
                   | DROP := DEPOSIT
                   | H_STOP_1 := H_STOP
                   | V_STOP_2 := V_STOP
                   |) where event ABOVE, DEPOSIT, OK_GO;
                            H_STOP, V_STOP; end
                | (| OK_GO := DROP
                   | ABOVE := D_ABOVE
                   | F_TO_D_MOVING{MAX_HEIGHT,INI_POS}
                   | GO_TO_DEP := GO_TO_DEPOSIT
                   | H_STOP_3 := H_STOP
                   | V_STOP_4 := V_STOP
                   |) where event ABOVE, OK_GO, GO_TO_DEPOSIT;
                            H_STOP, V_STOP; end
                | (| VST2 := V_STOP_4
                   | HST2 := H_STOP_3
                   | VST1 := V_STOP_2
                   | HST1 := H_STOP_1
                   | (| H_STOP := HST1 default HST2
                      | V_STOP := VST1 default VST2
                      |)
                   |) where HST1, VST1, HST2, VST2; end
                |)/ V_STOP_4, H_STOP_3, V_STOP_2, H_STOP_1 |)
            where 
            process D_TO_F_MOVING =
                 { real MIN_HEIGHT, INI_POS; }
                 ( ? event H;
                     event OK_GO;
                     event ABOVE;
                     real CURRENT_HEIGHT;
                     event DEPOSIT_ACCEPT;
                   ! event DEPOSIT;
                     event GO_TO_FEED;
                     event V_START_UP;
                     event V_STOP;
                     event H_STOP;
                 )
               (| DEPOSIT := CONTROL_ACTION(ABOVE,DEPOSIT_ACCEPT)
                | V_START_UP := SHIFT_EVT(OK_GO,H)
                | V_STOP := when ((CURRENT_HEIGHT<=MIN_HEIGHT) and (LAST_HEIGHT>MIN_HEIGHT))
                | LAST_HEIGHT := CURRENT_HEIGHT$1
                | GO_TO_FEED := V_STOP
                | H_STOP := ABOVE
                |)
               where 
               real LAST_HEIGHT init INI_POS;
               end
            ; 
            process F_TO_D_MOVING =
                 { real MAX_HEIGHT, INI_POS; }
                 ( ? event H;
                     event OK_GO;
                     event ABOVE;
                     real CURRENT_HEIGHT;
                     event PICK_ACCEPT;
                   ! event GO_TO_DEPOSIT;
                     event V_START_DOWN;
                     event H_STOP;
                     event V_STOP;
                     event PICK_UP;
                 )
               (| PICK_UP := CONTROL_ACTION(V_STOP,PICK_ACCEPT)
                | GO_TO_DEPOSIT := SHIFT_EVT(OK_GO,H)
                | V_START_DOWN := H_STOP
                | V_STOP := when ((CURRENT_HEIGHT>=MAX_HEIGHT) and (LAST_HEIGHT<MAX_HEIGHT))
                | LAST_HEIGHT := CURRENT_HEIGHT$1
                | H_STOP := ABOVE
                |)
               where 
               real LAST_HEIGHT init INI_POS;
               end
            ; 
            H_STOP_1, V_STOP_2, H_STOP_3, V_STOP_4;
            end
         ; 
         process DEPOSIT_BELT =
              ( ? event READY;
                  boolean SENSOR;
                ! event ACCEPT;
                  event START;
                  event STOP;
              )
            (| ACCEPT := when (not SENSOR)
             | STOP := when (not SENSOR)
             | START := READY
             |)
         ; 
         process FEED_BELT =
              { boolean TABLE_FREE; }
              ( ? event READY;
                  boolean SENSOR;
                ! event ACCEPT;
                  event START;
                  event STOP;
              )
            (| ACCEPT := when SENSOR
             | ALLOWED := STATUS(READY,when (not SENSOR))
             | STOP := (when SENSOR) when (not ALLOWED)
             | MOVING := STATUS(START,STOP)
             | START := READY when (not MOVING)
             | READY default SENSOR ^= ALLOWED ^= MOVING
             |)
            where 
            boolean ALLOWED init TABLE_FREE, MOVING init false;
            end
         ; 
         process TABLE =
              { real MIN_POS, MAX_POS, INI_POS; }
              ( ? event BOTTOM;
                  event TABLE_EMPTY;
                  real CURRENT_POS;
                  event H;
                  event TOP;
                  event TABLE_LOADED;
                ! event GO_TO_FEED;
                  event V_START_DOWN;
                  event READY_LOAD;
                  event H_STOP;
                  event V_STOP;
                  event GO_TO_ROBOT;
                  event V_START_UP;
                  event READY_UNLOAD;
              )
            (| (| (| OK_GO := TABLE_EMPTY
                   | OK_POS := BOTTOM
                   | R_TO_F_MOVING{MIN_POS,INI_POS}
                   | READY_LOAD := DEPOSIT_ACCEPT
                   | H_STOP_1 := H_STOP
                   | V_STOP_2 := V_STOP
                   |) where event OK_POS, OK_GO, DEPOSIT_ACCEPT, H_STOP, V_STOP; end
                | (| OK_GO := TABLE_LOADED
                   | OK_POS := TOP
                   | F_TO_R_MOVING{MAX_POS,INI_POS}
                   | READY_UNLOAD := ACCEPT_PICK_UP
                   | H_STOP_3 := H_STOP
                   | V_STOP_4 := V_STOP
                   |) where event OK_POS, OK_GO, ACCEPT_PICK_UP, H_STOP, V_STOP; end
                | (| VST2 := V_STOP_4
                   | HST2 := H_STOP_3
                   | VST1 := V_STOP_2
                   | HST1 := H_STOP_1
                   | (| H_STOP := HST1 default HST2
                      | V_STOP := VST1 default VST2
                      |)
                   |) where event HST1, VST1, HST2, VST2; end
                |)/ V_STOP_4, H_STOP_3, V_STOP_2, H_STOP_1 |)
            where 
            process R_TO_F_MOVING =
                 { real MIN_POS, INI_POS; }
                 ( ? event H;
                     event OK_GO;
                     event OK_POS;
                     real CURRENT_POS;
                   ! event DEPOSIT_ACCEPT;
                     event GO_TO_FEED;
                     event V_START_DOWN;
                     event V_STOP;
                     event H_STOP;
                 )
               (| GO_TO_FEED := OK_GO
                | DEPOSIT_ACCEPT := CONTROL_ACTION(V_STOP,H_STOP)
                | V_START_DOWN := GO_TO_FEED
                | H_STOP := when ((CURRENT_POS<=MIN_POS) and (LAST_POS>MIN_POS))
                | LAST_POS := CURRENT_POS$1
                | V_STOP := OK_POS
                |)
               where 
               real LAST_POS init INI_POS;
               end
            ; 
            process F_TO_R_MOVING =
                 { real MAX_POS, INI_POS; }
                 ( ? event H;
                     event OK_GO;
                     event OK_POS;
                     real CURRENT_POS;
                   ! event GO_TO_ROBOT;
                     event V_START_UP;
                     event H_STOP;
                     event V_STOP;
                     event ACCEPT_PICK_UP;
                 )
               (| GO_TO_ROBOT := OK_GO
                | ACCEPT_PICK_UP := CONTROL_ACTION(V_STOP,H_STOP)
                | V_START_UP := GO_TO_ROBOT
                | H_STOP := when ((CURRENT_POS>=MAX_POS) and (LAST_POS<MAX_POS))
                | LAST_POS := CURRENT_POS$1
                | V_STOP := OK_POS
                |)
               where 
               real LAST_POS init INI_POS;
               end
            ; 
            event H_STOP_1, V_STOP_2, H_STOP_3, V_STOP_4;
            end
         ; 
         ACCEPT_1, ACCEPT, ACCEPT_2;
         event TABLE_LOADED, READY_LOAD;
         end
      ; 
      process SENSORS_TRANSPORT =
           ( ? [14]real SENSORS;
             ! TABLE_LOW;
               TABLE_HIGH;
               real TABLE_ANGLE;
               CRANE_ABOVE_DEP;
               CRANE_ABOVE_FEED;
               real CRANE_HEIGHT;
               FEED_PHOTOCELL;
               DEP_PHOTOCELL;
               SENSORS_CLOCK;
           )
         (| TABLE_LOW := when FRONT{false}(SENSORS[6]=1.0e0)
          | TABLE_HIGH := when FRONT{false}(SENSORS[7]=1.0e0)
          | TABLE_ANGLE := SENSORS[8]
          | CRANE_ABOVE_DEP := when FRONT{false}(SENSORS[9]=1.0e0)
          | CRANE_ABOVE_FEED := when FRONT{false}(SENSORS[10]=1.0e0)
          | CRANE_HEIGHT := SENSORS[11]
          | FEED_PHOTOCELL := FRONT{false}(SENSORS[12]=1.0e0)
          | DEP_PHOTOCELL := FRONT{false}(SENSORS[13]=1.0e0)
          | SENSORS_CLOCK := ^SENSORS
          |)
      ; 
      process SEND_COMMANDS =
           ( ? BELT2_START;
               BELT2_STOP;
               BELT1_START;
               BELT1_STOP;
               CRANE_LOWER;
               CRANE_LIFT;
               CRANE_STOP_V;
               CRANE_TO_BELT2;
               CRANE_TO_BELT1;
               CRANE_STOP_H;
               CRANE_MAG_ON;
               CRANE_MAG_OFF;
               TABLE_UPWARD;
               TABLE_DOWNWARD;
               TABLE_STOP_V;
               TABLE_LEFT;
               TABLE_RIGHT;
               TABLE_STOP_H;
             ! COMMANDS_CLOCK;
           )
         (| SEND_COMMAND(1 when BELT2_START)
          | SEND_COMMAND(2 when BELT2_STOP)
          | SEND_COMMAND(3 when BELT1_START)
          | SEND_COMMAND(4 when BELT1_STOP)
          | SEND_COMMAND(5 when CRANE_LOWER)
          | SEND_COMMAND(6 when CRANE_LIFT)
          | SEND_COMMAND(7 when CRANE_STOP_V)
          | SEND_COMMAND(8 when CRANE_TO_BELT2)
          | SEND_COMMAND(9 when CRANE_TO_BELT1)
          | SEND_COMMAND(10 when CRANE_STOP_H)
          | SEND_COMMAND(11 when CRANE_MAG_ON)
          | SEND_COMMAND(12 when CRANE_MAG_OFF)
          | SEND_COMMAND(13 when TABLE_UPWARD)
          | SEND_COMMAND(14 when TABLE_DOWNWARD)
          | SEND_COMMAND(15 when TABLE_STOP_V)
          | SEND_COMMAND(16 when TABLE_LEFT)
          | SEND_COMMAND(17 when TABLE_RIGHT)
          | SEND_COMMAND(18 when TABLE_STOP_H)
          | COMMANDS_CLOCK := BELT2_START default BELT2_STOP default BELT1_START default BELT1_STOP default CRANE_LOWER default CRANE_LIFT default CRANE_STOP_V default CRANE_TO_BELT2 default CRANE_TO_BELT1 default CRANE_STOP_H default CRANE_MAG_ON default 
                              CRANE_MAG_OFF default TABLE_UPWARD default TABLE_DOWNWARD default TABLE_STOP_V default TABLE_LEFT default TABLE_RIGHT default TABLE_STOP_H
          |)
         where 
         process SEND_COMMAND =
              ( ? integer C;
              )
         
         ; 
         end
      ; 
      TABLE_LOW, TABLE_HIGH, TABLE_ANGLE, CRANE_ABOVE_DEP, CRANE_ABOVE_FEED, CRANE_HEIGHT, FEED_PHOTOCELL, DEP_PHOTOCELL, SENSORS_CLOCK, D_STOP, F_START, F_STOP, C_V_START_DOWN, C_V_START_UP, C_V_STOP, GO_CRANE_DEP, GO_CRANE_FEED, C_H_STOP, C_PICK_UP, 
      C_DROP, T_V_START_UP, T_START_DOWN, T_V_STOP, GO_TABLE_FEED, GO_TABLE_ROBOT, T_H_STOP;
      end
   ; 
   process CTRL_ROBOT_PRESS =
        { real ANGLE_MIN_ARM1_SAFE, ANGLE_MAX_ARM1_SAFE, ANGLE_MIN_ARM2_SAFE, ANGLE_MAX_ARM2_SAFE;
          boolean INI_MIDDLE; }
        ( ? [14]real SENSORS;
            event TABLE_READY_TO_UNLOAD;
            event BELT_READY_LOADED;
          ! COMMANDS_CLOCK;
            event TABLE_EMPTY;
        )
      (| (| (| REACT_CLOCK := SENSORS_CLOCK
             | POSITION_ROBOT := ROBOT_ANGLE
             | POSITION_ARM2 := ARM2_EXTENSION
             | POSITION_ARM1 := ARM1_EXTENSION
             | ROBOT_PRESS{ANGLE_MIN_ARM1_SAFE,ANGLE_MAX_ARM1_SAFE,ANGLE_MIN_ARM2_SAFE,ANGLE_MAX_ARM2_SAFE,INI_MIDDLE}
             |) where real POSITION_ARM1, POSITION_ARM2, POSITION_ROBOT;
                      event REACT_CLOCK; end
          | SENSORS_TRANSFORMATION{}
          | SEND_COMMANDS{}
          | (| H := SENSORS_CLOCK
             | (| TABLE_EMPTY := SHIFT_EVT(ARM1_MAG_ON,H) |)
             |) where event H; end
          |)/ SENSORS_CLOCK, ROBOT_ANGLE, ARM2_EXTENSION, ARM1_EXTENSION, PRESS_CLOSED, PRESS_MIDDLE, PRESS_LOW, ARM1_MAG_ON, ARM2_MAG_OFF, ARM2_FORWARD, ARM2_BACKWARD, ARM2_MAG_ON, ROBOT_LEFT, ROBOT_RIGHT, ROBOT_STOP, ARM1_FORWARD, ARM1_BACKWARD, 
              ARM1_MAG_OFF, ARM2_STOP, ARM1_STOP, PRESS_DOWNWARD, PRESS_UPWARD, PRESS_STOP |)
      where 
      process SENSORS_TRANSFORMATION =
           ( ? [14]real SENSORS;
             ! PRESS_LOW;
               PRESS_MIDDLE;
               PRESS_CLOSED;
               ARM1_EXTENSION;
               ARM2_EXTENSION;
               ROBOT_ANGLE;
               SENSORS_CLOCK;
           )
         (| PRESS_LOW := when FRONT{false}(SENSORS[0]=1.0e0)
          | PRESS_MIDDLE := when FRONT{false}(SENSORS[1]=1.0e0)
          | PRESS_CLOSED := when FRONT{false}(SENSORS[2]=1.0e0)
          | ARM1_EXTENSION := SENSORS[3]
          | ARM2_EXTENSION := SENSORS[4]
          | ROBOT_ANGLE := SENSORS[5]
          | SENSORS_CLOCK := ^SENSORS
          |)
      ; 
      process SEND_COMMANDS =
           ( ? event SENSORS_CLOCK;
               PRESS_UPWARD;
               PRESS_DOWNWARD;
               PRESS_STOP;
               ARM1_STOP;
               ARM2_STOP;
               ARM1_MAG_ON;
               ARM1_MAG_OFF;
               ARM1_BACKWARD;
               ARM1_FORWARD;
               ROBOT_STOP;
               ROBOT_RIGHT;
               ROBOT_LEFT;
               ARM2_MAG_ON;
               ARM2_MAG_OFF;
               ARM2_BACKWARD;
               ARM2_FORWARD;
             ! COMMANDS_CLOCK;
           )
         (| (| SEND_COMMAND(19 when PRESS_UPWARD)
             | SEND_COMMAND(20 when PRESS_DOWNWARD)
             | SEND_COMMAND(21 when PRESS_STOP)
             | SEND_COMMAND(22 when ARM1_STOP)
             | SEND_COMMAND(23 when ARM2_STOP)
             | SEND_COMMAND(24 when ARM1_MAG_ON)
             | SEND_COMMAND(25 when ARM1_MAG_OFF)
             | SEND_COMMAND(26 when ARM1_BACKWARD)
             | SEND_COMMAND(27 when ARM1_FORWARD)
             | c28 :: SEND_COMMAND(28 when ROBOT_STOP) | c28 ^= [: ROBOT_STOP]
             | c29_30 :: (| SEND_COMMAND(29 when ROBOT_RIGHT)
                          | SEND_COMMAND(30 when ROBOT_LEFT)
                          |) | c29_30 ^= [:ROBOT_RIGHT] ^+ [:ROBOT_LEFT]
             | SEND_COMMAND(31 when ARM2_MAG_ON)
             | SEND_COMMAND(32 when ARM2_MAG_OFF)
             | c33 :: SEND_COMMAND(33 when ARM2_BACKWARD)  | c33 ^= [: ARM2_BACKWARD]
             | SEND_COMMAND(34 when ARM2_FORWARD)
             | c35 :: SEND_COMMAND(35 when SENSORS_CLOCK)  | c35 ^= [: SENSORS_CLOCK]
             | COMMANDS_CLOCK := PRESS_UPWARD default PRESS_DOWNWARD default PRESS_STOP default ARM1_STOP default ARM2_STOP default ARM1_MAG_ON default ARM1_MAG_OFF default ARM1_BACKWARD default ARM1_FORWARD default ROBOT_STOP default ROBOT_RIGHT default 
                                 ROBOT_LEFT default ARM2_MAG_ON default ARM2_MAG_OFF default ARM2_BACKWARD default ARM2_FORWARD
             |)
          | (| c33 --> c35
             | c35 --> c28
             | c28 --> c29_30
             |)
          |)
         where 
         label c33, c35, c28, c29_30; 
         process SEND_COMMAND =
              ( ? integer C;
              )
         
         ; 
         end
      ; 
      process ROBOT_PRESS =
           { real ANGLE_MIN_ARM1_SAFE, ANGLE_MAX_ARM1_SAFE, ANGLE_MIN_ARM2_SAFE, ANGLE_MAX_ARM2_SAFE;
             boolean INI_MIDDLE; }
           ( ? event PRESS_CLOSED;
               event PRESS_MIDDLE;
               event PRESS_LOW;
               real POSITION_ARM2;
               real POSITION_ARM1;
               event REACT_CLOCK;
               real POSITION_ROBOT;
               event BELT_READY_LOADED;
               event TABLE_READY_TO_UNLOAD;
             ! event PRESS_STOP;
               event PRESS_UPWARD;
               event PRESS_DOWNWARD;
               event ARM1_BACKWARD;
               event ARM1_FORWARD;
               event ARM1_STOP;
               event ARM2_BACKWARD;
               event ARM2_FORWARD;
               event ARM2_STOP;
               event ROBOT_STOP;
               event ROBOT_RIGHT;
               event ROBOT_LEFT;
               event ARM1_MAG_ON;
               event ARM1_MAG_OFF;
               event ARM2_MAG_ON;
               event ARM2_MAG_OFF;
           )
         (| (| (| POS_TARGET := TARGET_ROT
                | LOAD_TARGET2 := TARGET_ARM2
                | LOAD_TARGET1 := TARGET_ARM1
                | P_GO_LOAD := P_UNLOADED
                | TRANSFORMATION{INI_MIDDLE}
                |) where event P_GO_LOAD;
                         boolean LOAD_TARGET1, LOAD_TARGET2;
                         integer POS_TARGET; end
             | (| PRESS_READY_UNLOADED := P_READY_UNLOADED
                | PRESS_READY_LOADED := P_READY_LOAD
                | SCHEDULING{ANGLE_MIN_ARM1_SAFE,ANGLE_MAX_ARM1_SAFE,ANGLE_MIN_ARM2_SAFE,ANGLE_MAX_ARM2_SAFE}
                |) where event PRESS_READY_LOADED, PRESS_READY_UNLOADED; end
             |)/ TARGET_ROT, READY_UNLOAD2, READY_LOAD2, TARGET_ARM2, READY_UNLOAD1, READY_LOAD1, TARGET_ARM1, P_UNLOADED, P_LOADED, P_READY_UNLOADED, P_READY_LOAD |)
         where 
         process TRANSFORMATION =
              { boolean INI_MIDDLE; }
              ( ? real POSITION_ARM1;
                  real POSITION_ARM2;
                  real POSITION_ROBOT;
                  integer POS_TARGET;
                  event READY_LOAD2;
                  event READY_UNLOAD2;
                  boolean LOAD_TARGET2;
                  event READY_LOAD1;
                  event READY_UNLOAD1;
                  boolean LOAD_TARGET1;
                  event REACT_CLOCK;
                  event P_GO_LOAD;
                  event P_LOADED;
                  event PRESS_LOW;
                  event PRESS_MIDDLE;
                  event PRESS_CLOSED;
                ! event ARM2_FORWARD;
                  event ARM2_BACKWARD;
                  event ARM2_MAG_OFF;
                  event ARM2_MAG_ON;
                  event ROBOT_LEFT;
                  event ROBOT_RIGHT;
                  event ROBOT_STOP;
                  event ARM1_FORWARD;
                  event ARM1_BACKWARD;
                  event ARM1_MAG_OFF;
                  event ARM1_MAG_ON;
                  event ARM2_STOP;
                  event ARM1_STOP;
                  event P_READY_UNLOADED;
                  event P_READY_LOAD;
                  event PRESS_DOWNWARD;
                  event PRESS_UPWARD;
                  event PRESS_STOP;
              )
            (| (| (| CONF_ALARM2 := CONFIRM_ALARM2
                   | CONF_ALARM1 := CONFIRM_ALARM1
                   | PRESS_POSITION_ARM2 := PRESS_LOW
                   | H := REACT_CLOCK
                   | ROBOT{}
                   |) where event H, PRESS_POSITION_ARM2;
                            boolean CONF_ALARM1, CONF_ALARM2; end
                | PRESS1{}
                | (| P_READY_UNLOAD := P_READY_UNLOADED
                   | H := REACT_CLOCK
                   | DEFENSE{INI_MIDDLE}
                   |) where event H, P_READY_UNLOAD; end
                | (| PRESS_POSITION_ARM1 := PRESS_MIDDLE default PRESS_LOW |)
                |)/ PRESS_POSITION_ARM1, CONFIRM_ALARM2, CONFIRM_ALARM1, SERIOUS_ALARM1, SERIOUS_ALARM2, FIN_ALARM2, FIN_ALARM1 |)
            where 
            process ROBOT =
                 ( ? real POSITION_ARM1;
                     boolean LOAD_TARGET1;
                     event READY_UNLOAD1;
                     event READY_LOAD1;
                     boolean CONF_ALARM1;
                     PRESS_POSITION_ARM1;
                     boolean CONF_ALARM2;
                     PRESS_POSITION_ARM2;
                     real POSITION_ROBOT;
                     real POSITION_ARM2;
                     boolean LOAD_TARGET2;
                     event READY_UNLOAD2;
                     event READY_LOAD2;
                     event H;
                     integer POS_TARGET;
                   ! event SERIOUS_ALARM1;
                     event FIN_ALARM1;
                     event FIN_ALARM2;
                     event SERIOUS_ALARM2;
                     event ARM1_MAG_ON;
                     event ARM1_MAG_OFF;
                     event ARM1_BACKWARD;
                     event ARM1_FORWARD;
                     event ARM1_STOP;
                     event ROBOT_STOP;
                     event ROBOT_RIGHT;
                     event ROBOT_LEFT;
                     event ARM2_MAG_ON;
                     event ARM2_MAG_OFF;
                     event ARM2_BACKWARD;
                     event ARM2_FORWARD;
                     event ARM2_STOP;
                 )
               (| (| (| H_ALARM := H_ALARM_7
                      | C_POS := POSITION_ROBOT
                      | ROTATE{CONST_POS}
                      |) where real C_POS;
                               H_ALARM; end
                   | (| STOP_ALARM1 := H_ALARM_2
                      | RESUME1 := RESUME_ARM_1
                      | C_POS1 := POSITION_ARM1
                      | ARM1{}
                      | ARM1_STOP := STOP1
                      |) where real C_POS1;
                               event STOP1, STOP_ALARM1;
                               RESUME1; end
                   | (| RESUME2 := RESUME_ARM_6
                      | STOP_ALARM2 := H_ALARM_5
                      | C_POS2 := POSITION_ARM2
                      | ARM2{}
                      | ARM2_STOP := STOP2
                      |) where real C_POS2;
                               event STOP2;
                               STOP_ALARM2, RESUME2; end
                   | (| RETRACTED := RETRACTED1
                      | CURRENT_ANGLE := POSITION_ROBOT
                      | PRESS_POSITION := PRESS_POSITION_ARM1
                      | CONF_ALARM := CONF_ALARM1
                      | CONTROL_ALARM{-90.0e0,-60.0e0}
                      | SERIOUS_ALARM1 := SERIOUS_ALARM
                      | FIN_ALARM1 := FIN_ALARM
                      | RESUME_ARM_1 := RESUME_ARM
                      | H_ALARM_2 := H_ALARM
                      | RESUME_ROT_3 := RESUME_ROT
                      |) where event SERIOUS_ALARM, FIN_ALARM, RETRACTED;
                               boolean CONF_ALARM;
                               PRESS_POSITION, RESUME_ARM, H_ALARM, RESUME_ROT;
                               real CURRENT_ANGLE; end
                   | (| RETRACTED := RETRACTED2
                      | CURRENT_ANGLE := POSITION_ROBOT
                      | PRESS_POSITION := PRESS_POSITION_ARM2
                      | CONF_ALARM := CONF_ALARM2
                      | CONTROL_ALARM{5.0e0,65.0e0}
                      | FIN_ALARM2 := FIN_ALARM
                      | SERIOUS_ALARM2 := SERIOUS_ALARM
                      | RESUME_ROT_4 := RESUME_ROT
                      | H_ALARM_5 := H_ALARM
                      | RESUME_ARM_6 := RESUME_ARM
                      |) where event FIN_ALARM, SERIOUS_ALARM, RETRACTED;
                               boolean CONF_ALARM;
                               PRESS_POSITION, RESUME_ROT, H_ALARM, RESUME_ARM;
                               real CURRENT_ANGLE; end
                   | (| ST2_ALARM := H_ALARM_5
                      | RESUME_ROT2 := RESUME_ROT_4
                      | RESUME_ROT1 := RESUME_ROT_3
                      | ST1_ALARM := H_ALARM_2
                      | (| H_ALARM := ST1_ALARM default ST2_ALARM
                         | RESUME := RESUME_ROT1 default RESUME_ROT2
                         |)
                      | H_ALARM_7 := H_ALARM
                      |) where ST1_ALARM, RESUME_ROT1, RESUME_ROT2, ST2_ALARM, H_ALARM; end
                   |)/ RESUME, H_ALARM_7, RESUME_ARM_6, H_ALARM_5, RESUME_ROT_4, RESUME_ROT_3, H_ALARM_2, RESUME_ARM_1, RETRACTED2, RETRACTED1 |)
               where 
               constant [4]real CONST_POS = [[0] : -85e0,[1] : -50.0e0,[2] : 30.0e0,[3] : 45.0e0];
               process ARM =
                    { real POS_SAFE, POS_LOAD, POS_UNLOAD, POS_INIT; }
                    ( ? boolean LOAD_TARGET;
                        event STOP_ALARM;
                        event READY_LOAD;
                        event READY_UNLOAD;
                        event RESUME;
                        event H;
                        real C_POS;
                      ! event MAG_ON;
                        event MAG_OFF;
                        event RETRACTED;
                        event STOP;
                        event E_START;
                        event R_START;
                    )
                  (| (| MOVEMENT{POS_INIT}
                      | (| H_ALARM := STOP_ALARM
                         | ARM_CONTROL{POS_SAFE,POS_LOAD,POS_UNLOAD}
                         | MAG_ON := ARM_MAG_ON
                         | MAG_OFF := ARM_MAG_OFF
                         |) where event H_ALARM, ARM_MAG_ON, ARM_MAG_OFF; end
                      |)/ TARGET, TARGET_STOP |)
                  where 
                  event P_E_START, P_R_START, TARGET_STOP;
                  real C_TARGET init 0.0, TARGET;
                  boolean N_C_RETRACT, RETRACT init false;
                  boolean N_MOVING, MOVING init false;
                  process ARM_CONTROL =
                       { real POS_SAFE;
                         real POS_LOAD, POS_UNLOAD; }
                       ( ? event H;
                           event H_ALARM;
                           event RESUME;
                           boolean LOAD_TARGET;
                           event TARGET_STOP;
                           event READY_LOAD;
                           event READY_UNLOAD;
                         ! event RETRACTED;
                           event STOP;
                           event ARM_MAG_ON;
                           event ARM_MAG_OFF;
                           real TARGET;
                       )
                     (| (| C_LOAD_TARGET := LOAD_TARGET cell (^H)
                         | GO_LOAD := LOAD_TARGET default (C_LOAD_TARGET when RESUME)
                         | ACT_TARGET := (POS_LOAD when GO_LOAD) default (POS_UNLOAD when (not GO_LOAD))
                         | STOP := TARGET_STOP
                         | ARM_MAG_ON := SHIFT_EVT(CONTROL_ACTION_RESET(when ALARM_BEGIN,READY_LOAD,STOP_LOAD),H)
                         | ARM_MAG_OFF := SHIFT_EVT(CONTROL_ACTION_RESET(when ALARM_BEGIN,READY_UNLOAD,STOP_UNLOAD),H)
                         |)
                      | (| RET_TARGET := POS_SAFE when H_ALARM
                         | N_ALARM := H_ALARM default (not TARGET_STOP) default ALARM
                         | ALARM := N_ALARM$1
                         | ALARM_BEGIN := FRONT{false}(ALARM)
                         | RETRACTED := TARGET_STOP when ALARM
                         | ALARM ^= H
                         |)
                      | TARGET := RET_TARGET default (ACT_TARGET when (not ALARM))
                      | STOP_LOAD := TARGET_STOP when (not ALARM) when C_LOAD_TARGET
                      | STOP_UNLOAD := TARGET_STOP when (not ALARM) when (not C_LOAD_TARGET)
                      |)
                     where 
                     event STOP_LOAD, STOP_UNLOAD;
                     real ACT_TARGET, RET_TARGET;
                     boolean N_ALARM, ALARM init false, GO_LOAD, C_LOAD_TARGET init false, ALARM_BEGIN;
                     end
                  ; 
                  end
               ; 
               process ROTATE =
                    { [4]real POS; }
                    ( ? event H_ALARM;
                        integer POS_TARGET;
                        event RESUME;
                        event H;
                        real C_POS;
                      ! event ROBOT_STOP;
                        event ROBOT_RIGHT;
                        event ROBOT_LEFT;
                    )
                  (| (| (| STOP := ROBOT_STOP
                         | MOVEMENT{0.0e0}
                         | ROBOT_RIGHT := E_START
                         | ROBOT_LEFT := R_START
                         |) where event STOP, E_START, R_START; end
                      | (| CONTROL{POS}
                         | ROBOT_STOP := STOP
                         |) where event STOP; end
                      |)/ TARGET, TARGET_STOP |)
                  where 
                  process CONTROL =
                       { [4]real POS; }
                       ( ? event H;
                           event H_ALARM;
                           integer POS_TARGET;
                           event TARGET_STOP;
                           event RESUME;
                         ! event STOP;
                           real TARGET;
                       )
                     (| C_LOAD_TARGET := (POS[POS_TARGET] when (^POS_TARGET)) cell H
                      | TARGET := (POS[POS_TARGET] when (^POS_TARGET)) default (C_LOAD_TARGET when RESUME)
                      | STOP := TARGET_STOP default H_ALARM
                      |)
                     where 
                     real C_LOAD_TARGET init 0.0e0;
                     end
                  ; 
                  event TARGET_STOP;
                  real TARGET;
                  end
               ; 
               process MOVEMENT =
                    { real POS_INIT; }
                    ( ? event STOP;
                        real TARGET;
                        real C_POS;
                      ! event E_START;
                        event R_START;
                        event TARGET_STOP;
                    )
                  (| (| N_MOVING := P_E_START default P_R_START default (not STOP) default MOVING
                      | MOVING := N_MOVING$1
                      | MOVING ^= C_POS
                      | C_TARGET := TARGET cell (^C_POS)
                      | N_C_RETRACT := P_R_START default (not P_E_START) default C_RETRACT
                      | C_RETRACT := N_C_RETRACT$1
                      | C_RETRACT ^= (when MOVING) default P_E_START default P_R_START
                      | TARGET_STOP := (((when (C_POS>=C_TARGET)) when (not C_RETRACT)) default ((when (C_POS<=C_TARGET)) when C_RETRACT)) when MOVING
                      | SORTIR(0 when TARGET_STOP)
                      | P_E_START := when ((C_POS when (^TARGET))<TARGET)
                      | P_R_START := when ((C_POS when (^TARGET))>TARGET)
                      | E_START := (P_E_START when (not MOVING)) default (P_E_START when C_RETRACT)
                      | R_START := (P_R_START when (not MOVING)) default (P_R_START when C_RETRACT)
                      |)/ MOVING, N_MOVING, P_E_START, P_R_START |)
                  where 
                  event P_E_START, P_R_START;
                  real C_TARGET init POS_INIT;
                  boolean N_C_RETRACT, C_RETRACT init true;
                  boolean MOVING init false;
                  boolean N_MOVING;
                  end
               ; 
               process ARM1 =
                    ( ? boolean LOAD_TARGET1;
                        event STOP_ALARM1;
                        event READY_LOAD1;
                        event READY_UNLOAD1;
                        event RESUME1;
                        real C_POS1;
                        event H;
                      ! event ARM1_MAG_ON;
                        event ARM1_MAG_OFF;
                        event RETRACTED1;
                        event STOP1;
                        event ARM1_FORWARD;
                        event ARM1_BACKWARD;
                    )
                  (| (| C_POS := C_POS1
                      | RESUME := RESUME1
                      | READY_UNLOAD := READY_UNLOAD1
                      | READY_LOAD := READY_LOAD1
                      | STOP_ALARM := STOP_ALARM1
                      | LOAD_TARGET := LOAD_TARGET1
                      | ARM{0.3708e0,0.5208e0,0.6458e0,0395800e0}
                      | ARM1_MAG_ON := MAG_ON
                      | ARM1_MAG_OFF := MAG_OFF
                      | RETRACTED1 := RETRACTED
                      | STOP1 := STOP
                      | ARM1_FORWARD := E_START
                      | ARM1_BACKWARD := R_START
                      |) where boolean LOAD_TARGET;
                               event STOP_ALARM, READY_LOAD, READY_UNLOAD, RESUME, MAG_ON, MAG_OFF, RETRACTED, STOP, E_START, R_START;
                               real C_POS; end |)
                  where 
                  event P_E_START, P_R_START;
                  real C_TARGET init 0.0;
                  boolean N_C_RETRACT, RETRACT init false;
                  boolean N_MOVING, MOVING init false;
                  end
               ; 
               process ARM2 =
                    ( ? boolean LOAD_TARGET2;
                        event STOP_ALARM2;
                        event READY_LOAD2;
                        event READY_UNLOAD2;
                        event RESUME2;
                        real C_POS2;
                        event H;
                      ! event ARM2_MAG_ON;
                        event ARM2_MAG_OFF;
                        event RETRACTED2;
                        event STOP2;
                        event ARM2_FORWARD;
                        event ARM2_BACKWARD;
                    )
                  (| (| C_POS := C_POS2
                      | RESUME := RESUME2
                      | READY_UNLOAD := READY_UNLOAD2
                      | READY_LOAD := READY_LOAD2
                      | STOP_ALARM := STOP_ALARM2
                      | LOAD_TARGET := LOAD_TARGET2
                      | ARM{0.0e0,0.7971e0,0.5707e0,0.457500e0}
                      | ARM2_MAG_ON := MAG_ON
                      | ARM2_MAG_OFF := MAG_OFF
                      | RETRACTED2 := RETRACTED
                      | STOP2 := STOP
                      | ARM2_FORWARD := E_START
                      | ARM2_BACKWARD := R_START
                      |) where boolean LOAD_TARGET;
                               event STOP_ALARM, READY_LOAD, READY_UNLOAD, RESUME, MAG_ON, MAG_OFF, RETRACTED, STOP, E_START, R_START;
                               real C_POS; end |)
                  where 
                  event P_E_START, P_R_START;
                  real C_TARGET init 0.0;
                  boolean N_C_RETRACT, RETRACT init false;
                  boolean N_MOVING, MOVING init false;
                  end
               ; 
               process CONTROL_ALARM =
                    { real SMALL_ANGLE, GREAT_ANGLE; }
                    ( ? boolean CONF_ALARM;
                        event RETRACTED;
                        real CURRENT_ANGLE;
                        event PRESS_POSITION;
                      ! event FIN_ALARM;
                        event SERIOUS_ALARM;
                        event H_ALARM;
                        event RESUME_ROT;
                        event RESUME_ARM;
                    )
                  (| H := ^CURRENT_ANGLE
                   | (| SAFE_ANGLE := (CURRENT_ANGLE<SMALL_ANGLE) or (CURRENT_ANGLE>GREAT_ANGLE)
                      | ALARM_ARM := (not SAFE_ANGLE) when (SAFE_ANGLE/=OLD_SAFE_ANGLE)
                      | OLD_SAFE_ANGLE := SAFE_ANGLE$1
                      |)
                   | (| SERIOUS_ALARM := (when ALARM_ARM) when (not SECURE_ARM)
                      | SECURE_ARM := NEXT_SECURE_ARM$1
                      | NEXT_SECURE_ARM := RETRACTED default (not RESUME_ARM) default SECURE_ARM
                      |)
                   | (| FIN_ALARM := when FRONT{false}(SECURE_ARM) |)
                   | H_ALARM := when CONF_ALARM
                   | RESUME_ROT := when (not CONF_ALARM)
                   | RESUME_ARM := (when (not ALARM_ARM)) default PRESS_POSITION
                   | SECURE_ARM ^= H
                   |)
                  where 
                  boolean SAFE_ANGLE, OLD_SAFE_ANGLE init true, ALARM_ARM, SECURE_ARM init false, NEXT_SECURE_ARM;
                  event H;
                  end
               ; 
               event RETRACTED1, RETRACTED2, H_ALARM_2, H_ALARM;
               RESUME_ARM_1, RESUME_ARM, RESUME_ROT_3, RESUME_ROT, RESUME_ROT_4, H_ALARM_5, RESUME_ARM_6, H_ALARM_7, RESUME;
               end
            ; 
            process PRESS1 =
                 ( ? event PRESS_CLOSED;
                     event PRESS_MIDDLE;
                     event PRESS_LOW;
                     event REACT_CLOCK;
                     event P_LOADED;
                     event P_GO_LOAD;
                   ! event P_READY_LOAD;
                     event P_READY_UNLOADED;
                     event PRESS_DOWNWARD;
                     event PRESS_STOP;
                     event PRESS_UPWARD;
                 )
               (| (| (| H := REACT_CLOCK
                      | (| PRESS_DOWNWARD := SHIFT_EVT(PRESS_CLOSED,H)
                         | P_M_STOP := PRESS_MIDDLE when PRESS_MOVING_UP
                         | PRESS_STOP := PRESS_LOW default P_M_STOP default PRESS_CLOSED
                         | PRESS_CAN_BE_UNLOADED := SHIFT_EVT(PRESS_LOW,H)
                         | PRESS_CAN_BE_LOADED := SHIFT_EVT(P_M_STOP,H)
                         |)
                      | P_READY_LOAD := PRESS_CAN_BE_LOADED
                      | P_READY_UNLOADED := PRESS_CAN_BE_UNLOADED
                      |) where event H, PRESS_CAN_BE_LOADED, PRESS_CAN_BE_UNLOADED; end/ P_M_STOP
                   | (| P_M_LOAD := P_LOADED
                      | H := REACT_CLOCK
                      | (| PRESS_UPWARD := P_M_LOAD default P_GO_LOAD
                         | N_PRESS_MOVING_UP := PRESS_UPWARD default (not PRESS_STOP) default PRESS_MOVING_UP
                         | PRESS_MOVING_UP := N_PRESS_MOVING_UP$1
                         | PRESS_MOVING_UP ^= H
                         |)
                      |) where event H, P_M_LOAD; end/ N_PRESS_MOVING_UP
                   |)/ PRESS_MOVING_UP |)
               where 
               event P_M_STOP;
               boolean PRESS_MOVING_UP init false, N_PRESS_MOVING_UP;
               end
            ; 
            process DEFENSE =
                 { boolean INI_MIDDLE; }
                 ( ? event PRESS_DOWNWARD;
                     event PRESS_UPWARD;
                     event P_READY_UNLOAD;
                     event P_READY_LOAD;
                     event SERIOUS_ALARM1;
                     event SERIOUS_ALARM2;
                     event H;
                     event FIN_ALARM2;
                     event FIN_ALARM1;
                   ! boolean CONFIRM_ALARM1;
                     boolean CONFIRM_ALARM2;
                 )
               (| GO := PRESS_UPWARD default PRESS_DOWNWARD
                | (| N_PRESS_MIDDLE_S := P_READY_LOAD default (not GO) default PRESS_MIDDLE_S
                   | PRESS_MIDDLE_S := N_PRESS_MIDDLE_S$1
                   | PRESS_MIDDLE_S ^= H
                   |)
                | (| N_PRESS_BOTTOM := P_READY_UNLOAD default (not GO) default PRESS_BOTTOM
                   | PRESS_BOTTOM := N_PRESS_BOTTOM$1
                   | PRESS_BOTTOM ^= H
                   |)
                | CONFIRM_ALARM1 := ((not (PRESS_BOTTOM or PRESS_MIDDLE_S)) when SERIOUS_ALARM1) default (not FIN_ALARM1)
                | CONFIRM_ALARM2 := ((not PRESS_BOTTOM) when SERIOUS_ALARM2) default (not FIN_ALARM2)
                |)
               where 
               boolean N_PRESS_MIDDLE_S, PRESS_MIDDLE_S init INI_MIDDLE, N_PRESS_BOTTOM, PRESS_BOTTOM init not INI_MIDDLE;
               event GO;
               end
            ; 
            event FIN_ALARM1, FIN_ALARM2, SERIOUS_ALARM2, SERIOUS_ALARM1;
            boolean CONFIRM_ALARM1, CONFIRM_ALARM2;
            PRESS_POSITION_ARM1;
            end
         ; 
         process SCHEDULING =
              { real ANGLE_MIN_ARM1_SAFE, ANGLE_MAX_ARM1_SAFE, ANGLE_MIN_ARM2_SAFE, ANGLE_MAX_ARM2_SAFE; }
              ( ? event PRESS_READY_LOADED;
                  event BELT_READY_LOADED;
                  event PRESS_READY_UNLOADED;
                  event TABLE_READY_TO_UNLOAD;
                  event REACT_CLOCK;
                  event ARM1_MAG_ON;
                  event ARM1_MAG_OFF;
                  event ARM2_MAG_ON;
                  event ARM2_MAG_OFF;
                  real POSITION_ROBOT;
                ! event READY_LOAD1;
                  event READY_UNLOAD1;
                  event READY_LOAD2;
                  event READY_UNLOAD2;
                  boolean TARGET_ARM1;
                  boolean TARGET_ARM2;
                  integer TARGET_ROT;
                  event P_LOADED;
                  event P_UNLOADED;
              )
            (| (| (| H := REACT_CLOCK
                   | ARM_STATES{}
                   |) where event H; end
                | (| BELT_READY_TO_BE_LOADED := EVT_2
                   | PRESS_CAN_BE_LOADED := EVT_1
                   | H := REACT_CLOCK
                   | PRESS_CAN_BE_UNLOADED := PRESS_READY_UNLOADED
                   | SCENARIO{}
                   |) where event PRESS_CAN_BE_UNLOADED, H;
                            PRESS_CAN_BE_LOADED, BELT_READY_TO_BE_LOADED; end
                | (| H := REACT_CLOCK
                   | N_EVT := PRESS_READY_LOADED
                   | INIT_STATE{}
                   | EVT_1 := EVT
                   |) where event N_EVT, H;
                            EVT; end
                | (| H := REACT_CLOCK
                   | N_EVT := BELT_READY_LOADED
                   | INIT_STATE{}
                   | EVT_2 := EVT
                   |) where event N_EVT, H;
                            EVT; end
                | (| INIT_PAR{ANGLE_MIN_ARM1_SAFE,ANGLE_MAX_ARM1_SAFE,ANGLE_MIN_ARM2_SAFE,ANGLE_MAX_ARM2_SAFE}
                   | P_LOADED := PRESS_LOADED
                   | P_UNLOADED := PRESS_UNLOADED
                   |) where event PRESS_LOADED, PRESS_UNLOADED; end
                |)/ EVT_2, EVT_1, GOAL_ARM2_DEPOSIT_BELT, GOAL_ARM2_PRESS, GOAL_ARM1_PRESS, GOAL_ARM1_TABLE, ARM2_FREE, ARM1_FREE |)
            where 
            PRESS_CAN_BE_UNLOADED, EVT_1, EVT, EVT_2;
            process INIT_PAR =
                 { real ANGLE_MIN_ARM1_SAFE, ANGLE_MAX_ARM1_SAFE, ANGLE_MIN_ARM2_SAFE, ANGLE_MAX_ARM2_SAFE; }
                 ( ? event GOAL_ARM1_TABLE;
                     event GOAL_ARM1_PRESS;
                     event GOAL_ARM2_PRESS;
                     event GOAL_ARM2_DEPOSIT_BELT;
                     boolean ARM1_FREE;
                     boolean ARM2_FREE;
                     real POSITION_ROBOT;
                   ! integer TARGET_ROT;
                     boolean TARGET_ARM2;
                     boolean TARGET_ARM1;
                     event READY_UNLOAD2;
                     event READY_LOAD2;
                     event READY_UNLOAD1;
                     event READY_LOAD1;
                     PRESS_UNLOADED;
                     PRESS_LOADED;
                 )
               (| (| PRESS_STATES{ANGLE_MIN_ARM1_SAFE,ANGLE_MAX_ARM1_SAFE,ANGLE_MIN_ARM2_SAFE,ANGLE_MAX_ARM2_SAFE}
                   | PRESS_UNLOADED := P_UNLOADED
                   | PRESS_LOADED := P_LOADED
                   |) where P_UNLOADED, P_LOADED; end
                | P_TARGET{}
                | GOAL_REACH{50.0e0,-90.0e0,35.0e0,-45.0e0}
                |)
               where 
               process P_TARGET =
                    ( ? event GOAL_ARM1_TABLE;
                        event GOAL_ARM1_PRESS;
                        event GOAL_ARM2_PRESS;
                        event GOAL_ARM2_DEPOSIT_BELT;
                      ! boolean TARGET_ARM1;
                        boolean TARGET_ARM2;
                        integer TARGET_ROT;
                    )
                  (| TARGET_ARM1 := GOAL_ARM1_TABLE default (not GOAL_ARM1_PRESS)
                   | TARGET_ARM2 := (not GOAL_ARM2_DEPOSIT_BELT) default GOAL_ARM2_PRESS
                   | TARGET_ROT := (0 when GOAL_ARM1_PRESS) default (1 when GOAL_ARM2_DEPOSIT_BELT) default (2 when GOAL_ARM2_PRESS) default (3 when GOAL_ARM1_TABLE)
                   |)
               ; 
               process GOAL_REACH =
                    { real POSITION_TABLE, POSITION_PRESS1, POSITION_PRESS2, POSITION_BELT; }
                    ( ? GOAL_ARM1_TABLE;
                        GOAL_ARM1_PRESS;
                        POSITION_ROBOT;
                        GOAL_ARM2_PRESS;
                        GOAL_ARM2_DEPOSIT_BELT;
                      ! READY_LOAD1;
                        READY_UNLOAD1;
                        READY_LOAD2;
                        READY_UNLOAD2;
                    )
                  (| (| (| GOAL := GOAL_ARM2_DEPOSIT_BELT
                         | SUB_GOAL_REACH{POSITION_BELT}
                         | READY_UNLOAD2 := READY
                         |) where GOAL, READY; end |)
                   | (| (| GOAL := GOAL_ARM2_PRESS
                         | SUB_GOAL_REACH{POSITION_PRESS2}
                         | READY_LOAD2 := READY
                         |) where GOAL, READY; end |)
                   | (| (| GOAL := GOAL_ARM1_PRESS
                         | SUB_GOAL_REACH{POSITION_PRESS1}
                         | READY_UNLOAD1 := READY
                         |) where GOAL, READY; end |)
                   | (| (| GOAL := GOAL_ARM1_TABLE
                         | SUB_GOAL_REACH{POSITION_TABLE}
                         | READY_LOAD1 := READY
                         |) where GOAL, READY; end |)
                   |)
                  where 
                  process SUB_GOAL_REACH =
                       { integer POSITION_TO_REACH; }
                       ( ? POSITION_ROBOT;
                           GOAL;
                         ! READY;
                       )
                     (| READY := CONTROL_ACTION2(GOAL,GOOD_POSITION)
                      | GOOD_POSITION := when (POSITION_ROBOT=POSITION_TO_REACH)
                      |)
                     where 
                     GOOD_POSITION;
                     end
                  ; 
                  end
               ; 
               process PRESS_STATES =
                    { real ANGLE_MIN_ARM1_SAFE, ANGLE_MAX_ARM1_SAFE, ANGLE_MIN_ARM2_SAFE, ANGLE_MAX_ARM2_SAFE; }
                    ( ? real POSITION_ROBOT;
                        boolean ARM1_FREE;
                        boolean ARM2_FREE;
                      ! event P_UNLOADED;
                        event P_LOADED;
                    )
                  (| (| ALARM1 := PRESS_DANGEROUS_ANGLE{ANGLE_MIN_ARM1_SAFE,ANGLE_MAX_ARM1_SAFE}(POSITION_ROBOT)
                      | ALARM2 := PRESS_DANGEROUS_ANGLE{ANGLE_MIN_ARM2_SAFE,ANGLE_MAX_ARM2_SAFE}(POSITION_ROBOT)
                      |)
                   | (| PRESS_ARM1 := (when ARM1_FREE) when (POSITION_ROBOT=(-90.0e0))
                      | P_LOADED := CONTROL_ACTION2(PRESS_ARM1,when (not ALARM1))
                      |)
                   | (| PRESS_ARM2 := (when (not ARM2_FREE)) when (POSITION_ROBOT=35.0e0)
                      | P_UNLOADED := CONTROL_ACTION2(PRESS_ARM2,when (not ALARM2))
                      |)
                   |)
                  where 
                  boolean ALARM1, ALARM2;
                  boolean PRESS_ARM2, PRESS_ARM1;
                  process PRESS_DANGEROUS_ANGLE =
                       { real ANGLE_MIN_ARM_SAFE, ANGLE_MAX_ARM_SAFE; }
                       ( ? real POSITION_ROBOT;
                         ! boolean ALARM_ARM;
                       )
                     (| SAFE_ANGLE := (POSITION_ROBOT<ANGLE_MIN_ARM_SAFE) or (POSITION_ROBOT>ANGLE_MAX_ARM_SAFE)
                      | ALARM_ARM := (not SAFE_ANGLE) when (SAFE_ANGLE/=OLD_SAFE_ANGLE)
                      | OLD_SAFE_ANGLE := SAFE_ANGLE$1
                      |)
                     where 
                     boolean SAFE_ANGLE;
                     boolean OLD_SAFE_ANGLE init true;
                     end
                  ; 
                  end
               ; 
               end
            ; 
            process INIT_STATE =
                 ( ? N_EVT;
                     event H;
                   ! EVT;
                 )
               (| ZX := X$1
                | X := not H
                | EVT := (when ZX) default N_EVT
                |)
               where 
               boolean X, ZX init true;
               end
            ; 
            process SCENARIO =
                 ( ? event TABLE_READY_TO_UNLOAD;
                     event PRESS_CAN_BE_LOADED;
                     event H;
                     event PRESS_CAN_BE_UNLOADED;
                     event BELT_READY_TO_BE_LOADED;
                     boolean ARM1_FREE;
                     real POSITION_ROBOT;
                     boolean ARM2_FREE;
                   ! event GOAL_ARM1_TABLE;
                     event GOAL_ARM1_PRESS;
                     event GOAL_ARM2_PRESS;
                     event GOAL_ARM2_DEPOSIT_BELT;
                 )
               (| (| (| (| ARM_S := ARM2_FREE
                         | S_SUPPORT := BELT_READY_TO_BE_LOADED
                         | GOAL2{}
                         |) where event S_SUPPORT;
                                  boolean ARM_S; end |)
                   | (| (| ARM_S := ARM2_FREE
                         | S_SUPPORT := PRESS_CAN_BE_UNLOADED
                         | GOAL1{}
                         | GOAL_1 := GOAL
                         |) where event S_SUPPORT;
                                  boolean ARM_S;
                                  GOAL; end |)
                   | (| (| ARM_S := ARM1_FREE
                         | S_SUPPORT := PRESS_CAN_BE_LOADED
                         | GOAL2{}
                         | GOAL_2 := GOAL
                         |) where event S_SUPPORT;
                                  boolean ARM_S;
                                  GOAL; end |)
                   | (| (| ARM_S := ARM1_FREE
                         | S_SUPPORT := TABLE_READY_TO_UNLOAD
                         | GOAL1{}
                         | GOAL_3 := GOAL
                         |) where event S_SUPPORT;
                                  boolean ARM_S;
                                  GOAL; end |)
                   | (| C_GOAL_ARM1_TABLE := GOAL_3
                      | C_GOAL_ARM1_PRESS := GOAL_2
                      | C_GOAL_ARM2_PRESS := GOAL_1
                      | C_GOAL_ARM2_DEPOSIT_BELT := GOAL
                      | (| GOAL_ARM1_TABLE := C_GOAL_ARM1_TABLE
                         | GOAL_ARM1_PRESS := C_GOAL_ARM1_PRESS
                         | GOAL_ARM2_PRESS := (when ARM1_FREE) when (POSITION_ROBOT=(-90.0e0))
                         | GOAL_ARM2_DEPOSIT_BELT := C_GOAL_ARM2_DEPOSIT_BELT
                         |)
                      |) where C_GOAL_ARM2_DEPOSIT_BELT, C_GOAL_ARM2_PRESS, C_GOAL_ARM1_PRESS, C_GOAL_ARM1_TABLE; end
                   |)/ GOAL_3, GOAL_2, GOAL_1, GOAL |)
               where 
               C_GOAL_ARM1, GOAL, GOAL_1, GOAL_2, GOAL_3;
               process GOAL1 =
                    ( ? event H;
                        event S_SUPPORT;
                        boolean ARM_S;
                      ! event GOAL;
                    )
                  (| (| C_GOAL := SHIFT_EVT(^(when ARM_S),H)
                      | GOAL := CONTROL_ACTION(C_GOAL,S_SUPPORT)
                      |)/ C_GOAL |)
                  where 
                  event C_GOAL;
                  end
               ; 
               process GOAL2 =
                    ( ? event H;
                        event S_SUPPORT;
                        boolean ARM_S;
                      ! event GOAL;
                    )
                  (| (| C_GOAL := SHIFT_EVT(when (not ARM_S),H)
                      | GOAL := CONTROL_ACTION(C_GOAL,S_SUPPORT)
                      |)/ C_GOAL |)
                  where 
                  C_GOAL;
                  end
               ; 
               end
            ; 
            process ARM_STATES =
                 ( ? event ARM1_MAG_ON;
                     event ARM1_MAG_OFF;
                     event H;
                     event ARM2_MAG_ON;
                     event ARM2_MAG_OFF;
                   ! boolean ARM1_FREE;
                     boolean ARM2_FREE;
                 )
               (| (| (| ARM_MAG_OFF := ARM1_MAG_OFF
                      | ARM_MAG_ON := ARM1_MAG_ON
                      | ARM_STATE{}
                      | ARM1_FREE := ARM_FREE
                      |) where event ARM_MAG_ON, ARM_MAG_OFF;
                               boolean ARM_FREE; end |)
                | (| (| ARM_MAG_OFF := ARM2_MAG_OFF
                      | ARM_MAG_ON := ARM2_MAG_ON
                      | ARM_STATE{}
                      | ARM2_FREE := ARM_FREE
                      |) where event ARM_MAG_ON, ARM_MAG_OFF;
                               boolean ARM_FREE; end |)
                |)
               where 
               process ARM_STATE =
                    ( ? ARM_MAG_ON;
                        ARM_MAG_OFF;
                        event H;
                      ! boolean ARM_FREE;
                    )
                  (| (| S_ARM := (true when ARM_MAG_OFF) default (false when ARM_MAG_ON) default C_S_ARM
                      | C_S_ARM := S_ARM$1
                      | C_S_ARM ^= H
                      |)
                   | ARM_FREE := FRONT{false}(S_ARM)
                   |)
                  where 
                  boolean S_ARM, C_S_ARM init true;
                  end
               ; 
               end
            ; 
            boolean ARM1_FREE, ARM2_FREE;
            event GOAL_ARM1_TABLE, GOAL_ARM1_PRESS, GOAL_ARM2_PRESS, GOAL_ARM2_DEPOSIT_BELT;
            end
         ; 
         event P_READY_LOAD, P_READY_UNLOADED, P_LOADED, P_UNLOADED, READY_LOAD1, READY_UNLOAD1, READY_LOAD2, READY_UNLOAD2;
         boolean TARGET_ARM1, TARGET_ARM2;
         integer TARGET_ROT;
         end
      ; 
      event PRESS_STOP, PRESS_UPWARD, PRESS_DOWNWARD, ARM1_STOP, ARM2_STOP, ARM1_MAG_OFF, ARM1_BACKWARD, ARM1_FORWARD, ROBOT_STOP, ROBOT_RIGHT, ROBOT_LEFT, ARM2_MAG_ON, ARM2_BACKWARD, ARM2_FORWARD, ARM2_MAG_OFF, ARM1_MAG_ON, PRESS_LOW, PRESS_MIDDLE, 
           PRESS_CLOSED, SENSORS_CLOCK;
      real ARM1_EXTENSION, ARM2_EXTENSION, ROBOT_ANGLE;
      end
   ; 
   process STATUS =
        ( ? event ON, OFF;
          ! boolean STATE;
        )
      (| NEXT_STATE := (not OFF) default ON default STATE
       | STATE := NEXT_STATE$1
       |)
      where 
      boolean NEXT_STATE;
      end
   ; 
   process CONTROL_ACTION =
        ( ? event ACTUATOR_READY;
            event SUPPORT_READY;
          ! event DO_IT;
        )
      (| READY := STATUS(ACTUATOR_READY,DO_IT)
       | POSSIBL := STATUS(SUPPORT_READY,DO_IT)
       | DO_IT := (ACTUATOR_READY when (SUPPORT_READY default POSSIBL)) default (SUPPORT_READY when READY)
       | ACTUATOR_READY default SUPPORT_READY ^= READY ^= POSSIBL
       |)
      where 
      event READY_UP, ON;
      boolean READY init false, POSSIBL init false;
      process STATUS =
           ( ? event ON, OFF;
             ! boolean STATE;
           )
         (| NEXT_STATE := (not OFF) default ON default STATE
          | STATE := NEXT_STATE$1
          |)
         where 
         boolean NEXT_STATE;
         end
      ; 
      end
   ; 
   process SHIFT_EVT =
        ( ? event EVT, H;
          ! event OUT;
        )
      (| NSTATES := EVT default (not H)
       | STATES := NSTATES$1
       | OUT := when STATES
       |)
      where 
      boolean NSTATES, STATES init false;
      end
   ; 
   process FRONT =
        { boolean V0; }
        ( ? BOOLEEN;
          ! FRONT;
        )
      (| (| FRONT := (when (BOOLEEN and (not ZBOOLEEN))) default (not (when ((not BOOLEEN) and ZBOOLEEN)))
          | ZBOOLEEN := BOOLEEN$1
          |)/ ZBOOLEEN |)
      where 
      boolean ZBOOLEEN init V0;
      end
   ; 
   process SORTIR =
        ( ? integer C;
        )
   
   ; 
   process CONTROL_ACTION2 =
        ( ? event ACTUATOR_READY;
            event SUPPORT_READY;
          ! event DO_IT;
        )
      (| READY := STATUS(ACTUATOR_READY,DO_IT)
       | DO_IT := SUPPORT_READY when READY
       | ACTUATOR_READY default SUPPORT_READY ^= READY
       |)
      where 
      event READY_UP, ON;
      boolean READY init false;
      process STATUS =
           ( ? event ON, OFF;
             ! boolean STATE;
           )
         (| NEXT_STATE := (not OFF) default ON default STATE
          | STATE := NEXT_STATE$1
          |)
         where 
         boolean NEXT_STATE;
         end
      ; 
      end
   ; 
   process CONTROL_ACTION_RESET =
        ( ? event RESET;
            event ACTUATOR_READY;
            event SUPPORT_READY;
          ! event DO_IT;
        )
      (| READY := STATUS(RESET,ACTUATOR_READY,DO_IT)
       | POSSIBL := STATUS(RESET,SUPPORT_READY,DO_IT)
       | DO_IT := (ACTUATOR_READY when (SUPPORT_READY default POSSIBL)) default (SUPPORT_READY when READY)
       | ACTUATOR_READY default SUPPORT_READY default RESET ^= READY ^= POSSIBL
       |)
      where 
      event READY_UP, ON;
      boolean READY init false, POSSIBL init false;
      process STATUS =
           ( ? event RESET;
               event ON;
               event OFF;
             ! boolean STATE;
           )
         (| NEXT_STATE := (not OFF) default (not RESET) default ON default STATE
          | STATE := NEXT_STATE$1
          |)
         where 
         boolean NEXT_STATE;
         end
      ; 
      end
   ; 
   event TABLE_READY_TO_UNLOAD, DEPOSIT_BELT_READY_LOADED, TABLE_EMPTY, I3;
   COMMANDS_CLOCK_1, COMMANDS_CLOCK, COMMANDS_CLOCK_2;
   end
; 
