package SignalLibraries.Java;

import java.io.BufferedReader;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.Vector;

// class to read inputs
public class InputReader
{
    private BufferedReader dis;
    private boolean eof	= false;

    public void open(String fileName)
    {
	FileInputStream fis;
	try
	    {
		fis = new FileInputStream(fileName);
		dis = new BufferedReader(new InputStreamReader(fis));
	    }
	catch (FileNotFoundException e)
	    {
		System.err.println("\tCan not open file: " + fileName);
		System.err.println("Possible reason: " + fileName + " does not exist, read permission denied");
		System.exit(1);
	    }
    }

    public void close()
    {
	try
	    {
		dis.close();
	    }
	catch (IOException e)
	    {}
    }

    public int readInt()
    {
	int v;

	try
	    {
		String s = dis.readLine();
		s = s.trim();
		v = Integer.parseInt(s);
	    }
	catch (Exception e)
	    {
		eof = true;
		return 0;
	    }
	return v;
    }

    public int readint()
    {
	int i = 0, res = 0, vi = 0;
	char v = 'z';
	// Vector<Character> val = new Vector<Character>();
	Vector val = new Vector();
	Object O;

	while (vi != -1 && v != ' ' && v != '\n' && v != '\r')
	    {
		try
		    {
			vi = dis.read();
		    }
		catch (IOException e)
		    {
			eof = true;
		    }
		v = (char) vi;

		if (v != ' ' && v != '\n' && v != '\r')
		    {
			val.addElement(new Character(v));
			i++;
		    }
	    }
	if (vi != -1)
	    for (int k = 0; k < i; k++)
		{
		    O = val.elementAt(i - k - 1);
		    v = ((Character) O).charValue();

		    res = res + (v - 48) * (int) Math.pow(10.0, (double) k);

		}
	else
	    eof = true;

	return res;
    }

    public int[] readArrayInt()
    {
	String s, va;
	int v, newind, lg, i = 0;
	int[] tab;
	int ind = 0;

	try
	    {
		s = dis.readLine();
	    }
	catch (IOException e)
	    {
		eof = true;
		return null;
	    }
	lg = s.length();
	tab = new int[lg];

	while (ind < lg)
	    {
		newind = s.indexOf(" ", ind);
		va = s.substring(ind, newind);
		ind = newind + 1;

		try
		    {
			v = Integer.parseInt(va);
		    }
		catch (Exception e)
		    {
			eof = true;
			return null;
		    }
		System.out.println(v);
		tab[i] = v;
		i++;
	    }

	return tab;
    }

    public short readShort()
    {
	short v;

	try
	    {
		String s = dis.readLine();
		s = s.trim();
		v = Short.parseShort(s);
	    }
	catch (Exception e)
	    {
		eof = true;
		return 0;
	    }
	return v;
    }

    public long readLong()
    {
	long v;

	try
	    {
		String s = dis.readLine();
		s = s.trim();
		v = Long.parseLong(s);
	    }
	catch (Exception e)
	    {
		eof = true;
		return 0;
	    }
	return v;
    }

    public float readFloat()
    {
	float v;

	try
	    {
		String s = dis.readLine();
		s = s.trim();
		v = Float.parseFloat(s);
	    }
	catch (Exception e)
	    {
		eof = true;
		return (float)0;
	    }
	return v;
    }

    public double readDouble()
    {
	double v;

	try
	    {
		String s = dis.readLine();
		s = s.trim();
		v = Double.parseDouble(s);
	    }
	catch (Exception e)
	    {
		eof = true;
		return (double) 0;
	    }
	return v;
    }

    public boolean readBool()
    {
	boolean v;

	try
	    {
		String s = dis.readLine();
		s = s.trim();
		if (s.compareTo("1") == 0)
		    v = true;
		else if (s.compareTo("0") == 0)
		    v = false;
		else
		    v = Boolean.getBoolean(s);
	    }
	catch (Exception e)
	    {
		eof = true;
		return false;
	    }
	return v;
    }

    public String readString()
    {
	String s;
	try
	    {
		s = dis.readLine();
	    }
	catch (IOException e)
	    {
		eof = true;
		return "";
	    }
	return s;
    }

    public boolean isEof()
    {
	return eof;
    }

}
