
#ifndef __FIFOMANAGER_H__
#define __FIFOMANAGER_H__

/* Definition of the manager node */
typedef class FIFOManagerNode *ptFIFOManagerNode;
class FIFOManagerNode
{
 private :
  FIFOAssoc_type contents;                                 /* Contents of a node */
  ptFIFOManagerNode next;                                         /* Next node */

 public :
  FIFOManagerNode();
  FIFOManagerNode(FIFOAssoc_type componentRecord);
  ~FIFOManagerNode();
  void setValue(FIFOAssoc_type value);
  void setNext(ptFIFOManagerNode ptvalue);
  FIFOAssoc_type getValue();
  ptFIFOManagerNode getNext();
};

/* Manager type definition */
typedef class FIFOManager *ptFIFOManager;
class FIFOManager
{
 private :
  ptFIFOManagerNode first;                        /* First node in the manager */
  ptFIFOManagerNode last;                          /* Last node in the manager */
  int max_size;                                     /* Size limit of the manager */
  int current_size;                    /* Current number of nodes in the manager */

  void setFirst(ptFIFOManagerNode ptvalue);
  void setLast(ptFIFOManagerNode ptvalue);
  ptFIFOManagerNode getFirst();
  ptFIFOManagerNode getLast();

 public :
  FIFOManager();
  FIFOManager(int size);
  ~FIFOManager();
  /* If the manager was not full, a new FIFO node is created, initialized
     with input parameters and it is returned true. Else, it is returned false. */
  bool FIFORecord(pK_String FIFO_Name, int FIFO_Size, int message_Size, Data_type default_msg, ID_type& FIFOID);
  /* If a FIFO named FIFO_Name exists in the manager, FIFOID is its 
     identifier and it is returned true. Else, it is returned false */
  bool FIFOCheckName(pK_String FIFO_Name, ID_type& FIFOID); 
  /* If there is an identifier FIFOID in the manager, buff is the 
     FIFO associated and it is returned true. Else, it is returned false */
  bool FIFOCheckID(ID_type FIFOID, FIFO_type& fifo);
  /* The FIFO from the manager, which has the same name as buff, is updated */
  void FIFOUpdate(ID_type FIFOID, FIFO_type& fifo);

};
#endif // __FIFOMANAGER_H__










