module AADL_EVENTDATAPORT =

use fifoLib;


%--------------------------------------------------------------------------------%


%at Frozen_time_event, frozen current elements of in_fifo to frozen_fifo, 
 the thread can access the frozen_fifo each time when a dequeue action is performed, 
 dequeue_number is constraint in the property%

process InEventDataPort_Behavior =
  { type msg_type;
    msg_type def_value; 
    integer size, dequeue_number; 
    string port_name;}
  (? msg_type write_flow;
     event Frozen_time_event;
     event Initialize_time;
   ! msg_type read_flow;)
  (| (out1, cnt1) := fifo{msg_type, size, def_value}(write_flow)               %in_fifo%
   %| cnt1 ^= write_flow ^+ out1%
   | out1 ^= Frozen_time_event
   | tmp := out1 when Frozen_time_event
   | (read_flow, cnt) := fifo{ msg_type, dequeue_number, def_value}(tmp)        %frozen_fifo%
   %| cnt ^= tmp ^+ read_flow%
   |)
where
  shared integer cnt1;
  integer cnt;
  msg_type out1, tmp;
end;


%--------------------------------------------------------------------------------%

%the output is queued, and sent out at Output_time_event%

process OutEventDataPort_Behavior =
{ type msg_type;
  msg_type def_msg;
  integer size; 
  string port_name;
  }
(?  msg_type write_flow;  
    event Output_time_event;
    event Initialize_time;
 !  msg_type sent_flow;)
  (| (outx, cntx) := fifo{msg_type, size, def_msg}(write_flow)
   | outx ^= Output_time_event
   %| cntx ^= write_flow ^+ outx%
   | sent_flow := outx when Output_time_event
   | )
   where
     msg_type outx;
     integer cntx;
   end;

end;
